//a function to inspect a string to see if it is a valid uint32, then convert it if it is

#define BUILDING_LIB 1

#include <stdio.h>
#include <memory>
#include <SupportDefs.h>
//#include <string>
#include <String.h>
#include <string.h>
#include <stdlib.h>
#include <limits.h>
#include <float.h>
#include <errno.h>
#include <ctype.h>
#include <Application.h>
#include <Rect.h>
#include <Message.h>
#include <MenuItem.h>
#include <MenuBar.h>
#include <PopUpMenu.h>
#include <Window.h>
#include <View.h>
#include <SupportDefs.h>
#include <Beep.h>
#include <List.h>
#include <TextControl.h>
#include <TextView.h>
#include <ScrollView.h>
#include <Font.h>
#include <OS.h>
#include <Button.h>
#include <StatusBar.h>
#include <CheckBox.h>
#include <PictureButton.h>
#include <ColorControl.h>
#include <RadioButton.h>
#include <Point.h>
#include <TypeConstants.h>
#include <ListView.h>
#include <GraphicsDefs.h>
#include <File.h>
#include <Screen.h>
#include <Alert.h>
#include <Resources.h>
#include <StringView.h>
#include "DnumSpecificWindows.h"
#include "s2uint32.h"
#include "warning.h"
#include "Preferences.h"
#include "myPreferences.h"

uint32 
s2uint32(	const char * in) 
{
	/*Joerg (Stegemenn??) said to try using strtoul, so here is a first approximation
	It seems to me we need a whole new range of these:
	uint32 strtouint32(char, char *, int);
	int32 strtoint32(char, char *, int);
	int64 strtoint64(char, char *, int);
	etc.
	I'm not even sure in reality that the following is correct for uint32!
	*/
	//first we must test for negativity in the string--strtoul() does not do this
	long			len = strlen(in);
	for (	long i = 0;
			i < len;
			i++)
	{
		if (in[i] == '-')
		{
			warning(myPrefs->S2UI32Neg);
			return(0);
		}
		else if (!(isspace(in[i])))//just skip over whitespaces
		{
			i = len;
		}
	}
	char *			cpError = NULL;
	unsigned long	ulResult = strtoul(in, &cpError, 10);
	if (errno == ERANGE)
	{
		warning(myPrefs->S2UI32TooBig);
		return(ULONG_MAX);
	}
	else if (*cpError)
	{
		warning(myPrefs->S2UI32Invalid);
		return(0);
	}
	else return (uint32)ulResult;
}//end